/**
 * Event arguments for the
 * selectionChanged event.
*/
export class IgxSpreadsheetSelectionChangedEventArgs {
    constructor() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Returns the pane whose selection has been changed.
    */
    get pane() {
        return this.i.pane;
    }
}
