import { __extends } from "tslib";
import { IgxCancelEventArgs } from "igniteui-angular-core";
/**
 * Event arguments for the
 * actionExecuting event.
*/
var IgxSpreadsheetActionExecutingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxSpreadsheetActionExecutingEventArgs, _super);
    function IgxSpreadsheetActionExecutingEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxSpreadsheetActionExecutingEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSpreadsheetActionExecutingEventArgs.prototype, "command", {
        /**
         * Returns the command which will be executed on the
         * Spreadsheet.
        */
        get: function () {
            return this.i.command;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSpreadsheetActionExecutingEventArgs.prototype, "commandParameter", {
        /**
         * Returns the parameter which will be used when executing the command.
        */
        get: function () {
            return this.i.commandParameter;
        },
        enumerable: false,
        configurable: true
    });
    return IgxSpreadsheetActionExecutingEventArgs;
}(IgxCancelEventArgs));
export { IgxSpreadsheetActionExecutingEventArgs };
