import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { IgxExcelCoreModule } from "igniteui-angular-excel";
import { IgxSpreadsheetComponent } from './igx-spreadsheet-component';
import { SpreadsheetLocaleEn } from './SpreadsheetLocaleEn';
import { UndoLocaleEn } from './UndoLocaleEn';
import { Localization } from "igniteui-angular-core";
import * as i0 from "@angular/core";
var IgxSpreadsheetCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgxSpreadsheetCoreModule() {
        Localization.register("undo", new UndoLocaleEn());
        Localization.register("spreadsheet", new SpreadsheetLocaleEn());
    }
    IgxSpreadsheetCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxSpreadsheetCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    IgxSpreadsheetCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxSpreadsheetCoreModule, declarations: [IgxSpreadsheetComponent], imports: [CommonModule,
            IgxExcelCoreModule], exports: [IgxSpreadsheetComponent] });
    IgxSpreadsheetCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxSpreadsheetCoreModule, imports: [[CommonModule,
                IgxExcelCoreModule
            ]] });
    return IgxSpreadsheetCoreModule;
}());
export { IgxSpreadsheetCoreModule };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxSpreadsheetCoreModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        IgxSpreadsheetComponent
                    ],
                    exports: [
                        IgxSpreadsheetComponent
                    ],
                    imports: [CommonModule,
                        IgxExcelCoreModule
                    ],
                    entryComponents: []
                }]
        }], ctorParameters: function () { return []; } });
