import { __extends } from "tslib";
import { IgxCancelEventArgs } from "igniteui-angular-core";
import { ensureBool } from "igniteui-angular-core";
/**
 * Event arguments for the
 * editModeExiting event.
*/
var IgxSpreadsheetEditModeExitingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxSpreadsheetEditModeExitingEventArgs, _super);
    function IgxSpreadsheetEditModeExitingEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxSpreadsheetEditModeExitingEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSpreadsheetEditModeExitingEventArgs.prototype, "acceptChanges", {
        /**
         * Returns or sets a boolean indicating whether the changes will be made to the cell's value when edit mode ends.
        */
        get: function () {
            return this.i.acceptChanges;
        },
        set: function (v) {
            this.i.acceptChanges = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSpreadsheetEditModeExitingEventArgs.prototype, "canCancel", {
        /**
         * Returns a boolean indicating if the edit mode is being forced to exit edit mode in which case it cannot be cancelled.
        */
        get: function () {
            return this.i.canCancel;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSpreadsheetEditModeExitingEventArgs.prototype, "cell", {
        /**
         * Returns the cell for which the control is exiting edit mode.
        */
        get: function () {
            return this.i.cell;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSpreadsheetEditModeExitingEventArgs.prototype, "editText", {
        /**
         * Returns the edit text that will be used to update the cell(s).
        */
        get: function () {
            return this.i.editText;
        },
        enumerable: false,
        configurable: true
    });
    return IgxSpreadsheetEditModeExitingEventArgs;
}(IgxCancelEventArgs));
export { IgxSpreadsheetEditModeExitingEventArgs };
