import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum SpreadsheetPaneManager_ChangeActions {
    None = 0,
    DirtyLayout = 1,
    DirtyUsedRange = 3,
    ClearCellInfos = 5,
    DirtyRangeSizes = 9,
    DirtyPaneSettings = 17,
    ZoomChanged = 49,
    DirtyActiveCell = 64,
    HeaderSettings = 128,
    StyleChanged = 257,
    RedrawShapes = 515,
    UpdateCachedProperties = 1024,
    SelectUnlockedCell = 2048,
    ValidationRulesChanged = 4096,
    DirtyActiveTable = 8192,
    DirtyDropDownButtons = 16384,
    DirtyConditionalFormats = 32768,
    DirtyChartData = 65536
}
/**
 * @hidden
 */
export declare let SpreadsheetPaneManager_ChangeActions_$type: Type;
