/**
 * Event arguments for the
 * actionExecuted event.
*/
export class IgxSpreadsheetActionExecutedEventArgs {
    constructor() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Returns the command which was executed on the
     * Spreadsheet.
    */
    get command() {
        return this.i.command;
    }
    /**
     * Returns the parameter used when executing the command.
    */
    get commandParameter() {
        return this.i.commandParameter;
    }
}
