import { __extends } from "tslib";
import { IgxCancelEventArgs } from "igniteui-angular-core";
/**
 * Event arguments for the
 * editRangePasswordNeeded event.
*/
var IgxSpreadsheetEditRangePasswordNeededEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxSpreadsheetEditRangePasswordNeededEventArgs, _super);
    function IgxSpreadsheetEditRangePasswordNeededEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxSpreadsheetEditRangePasswordNeededEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSpreadsheetEditRangePasswordNeededEventArgs.prototype, "ranges", {
        /**
         * Returns the collection of protected ranges that should be unlocked.
         * This collection contains the protected ranges that overlap with the
         * locked cells that need to be unlocked. There may be multiple ranges that overlap the locked
         * cells so it may not be that every range needs to be unlocked.
        */
        get: function () {
            return this.i.ranges;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Unlocks the associated range(s) without validating the password.
    
    */
    IgxSpreadsheetEditRangePasswordNeededEventArgs.prototype.unprotect = function () {
        this.i.unprotect();
    };
    return IgxSpreadsheetEditRangePasswordNeededEventArgs;
}(IgxCancelEventArgs));
export { IgxSpreadsheetEditRangePasswordNeededEventArgs };
