import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { IWorksheetCellFormat } from "igniteui-angular-excel";
import { HorizontalCellAlignment } from "igniteui-angular-excel";
import { WorksheetCellFormatData } from "igniteui-angular-excel";
import { WorkbookColorInfo } from "igniteui-angular-excel";
import { CellBorderLineStyle } from "igniteui-angular-excel";
import { DiagonalBorders } from "igniteui-angular-excel";
import { CellFill } from "igniteui-angular-excel";
import { IWorkbookFont } from "igniteui-angular-excel";
import { WorksheetCellFormatOptions } from "igniteui-angular-excel";
import { WorkbookStyle } from "igniteui-angular-excel";
import { VerticalCellAlignment } from "igniteui-angular-excel";
/**
 * @hidden
 */
export declare class ReadOnlyResolvedWorksheetCellFormatData extends Base implements IWorksheetCellFormat {
    static $t: Type;
    private _b;
    private _a;
    constructor(a: WorksheetCellFormatData);
    _c(a: WorksheetCellFormatData): void;
    setFormatting(a: IWorksheetCellFormat): void;
    get alignment(): HorizontalCellAlignment;
    set alignment(a: HorizontalCellAlignment);
    get bottomBorderColorInfo(): WorkbookColorInfo;
    set bottomBorderColorInfo(a: WorkbookColorInfo);
    get bottomBorderStyle(): CellBorderLineStyle;
    set bottomBorderStyle(a: CellBorderLineStyle);
    get diagonalBorderColorInfo(): WorkbookColorInfo;
    set diagonalBorderColorInfo(a: WorkbookColorInfo);
    get diagonalBorders(): DiagonalBorders;
    set diagonalBorders(a: DiagonalBorders);
    get diagonalBorderStyle(): CellBorderLineStyle;
    set diagonalBorderStyle(a: CellBorderLineStyle);
    get fill(): CellFill;
    set fill(a: CellFill);
    get font(): IWorkbookFont;
    get formatOptions(): WorksheetCellFormatOptions;
    set formatOptions(a: WorksheetCellFormatOptions);
    get formatString(): string;
    set formatString(a: string);
    get indent(): number;
    set indent(a: number);
    get leftBorderColorInfo(): WorkbookColorInfo;
    set leftBorderColorInfo(a: WorkbookColorInfo);
    get leftBorderStyle(): CellBorderLineStyle;
    set leftBorderStyle(a: CellBorderLineStyle);
    get hidden(): boolean | null;
    set hidden(a: boolean | null);
    get _hidden$i(): Nullable$1<boolean>;
    set _hidden$i(a: Nullable$1<boolean>);
    get locked(): boolean | null;
    set locked(a: boolean | null);
    get _locked$i(): Nullable$1<boolean>;
    set _locked$i(a: Nullable$1<boolean>);
    get rightBorderColorInfo(): WorkbookColorInfo;
    set rightBorderColorInfo(a: WorkbookColorInfo);
    get rightBorderStyle(): CellBorderLineStyle;
    set rightBorderStyle(a: CellBorderLineStyle);
    get rotation(): number;
    set rotation(a: number);
    get shrinkToFit(): boolean | null;
    set shrinkToFit(a: boolean | null);
    get _shrinkToFit$i(): Nullable$1<boolean>;
    set _shrinkToFit$i(a: Nullable$1<boolean>);
    get style(): WorkbookStyle;
    set style(a: WorkbookStyle);
    get topBorderColorInfo(): WorkbookColorInfo;
    set topBorderColorInfo(a: WorkbookColorInfo);
    get topBorderStyle(): CellBorderLineStyle;
    set topBorderStyle(a: CellBorderLineStyle);
    get verticalAlignment(): VerticalCellAlignment;
    set verticalAlignment(a: VerticalCellAlignment);
    get wrapText(): boolean | null;
    set wrapText(a: boolean | null);
    get _wrapText$i(): Nullable$1<boolean>;
    set _wrapText$i(a: Nullable$1<boolean>);
}
