import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum SpreadsheetCursor {
    Arrow = 0,
    AutoFill = 1,
    DragCopy = 2,
    DragMove = 3,
    DragSheet = 4,
    ResizeColumn = 5,
    ResizeRow = 6,
    Rotate = 7,
    Rotating = 8,
    SelectColumn = 9,
    SelectMode = 10,
    SelectRow = 11,
    UnhideRow = 12,
    UnhideColumn = 13,
    ResizePaneColumnSplit = 14,
    ResizePaneRowSplit = 15,
    ResizePaneSplitIntersection = 16,
    Hyperlink = 17,
    TabItemSplit = 18,
    DropDownButton = 19
}
/**
 * @hidden
 */
export declare let SpreadsheetCursor_$type: Type;
